require "icon-artist"

include IconArtist

icons = []

ARGV.each do |file|
  icon = Icon.new file
  icon_params = icon.export "../build"
  icons += [icon_params]
end

theme = IconTheme.new("../build", {:create => true,
                                   :icons => icons,
                                   :name => "Echo Perspective",
                                   :comment => "Echo Icon Theme using perspective projection",
                                   :inherits => "Echo"})
theme.save
