#include <stdio.h>

#define COLS 5

#define ICON_16		printf ("\t\t\t<img src=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/16x16/%s/%s.png;hb=HEAD\" width=\"16px\" height=\"16px\" alt=\"-\"/>\n", category, icon_name[j]);

#define ICON_22		printf ("\t\t\t<img src=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/22x22/%s/%s.png;hb=HEAD\" width=\"22px\" height=\"22px\" alt=\"-\"/>\n", category, icon_name[j]);

#define ICON_24		printf ("\t\t\t<img src=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/24x24/%s/%s.png;hb=HEAD\" width=\"24px\" height=\"24px\" alt=\"-\"/>\n", category, icon_name[j]);

#define ICON_32		printf ("\t\t\t<img src=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/32x32/%s/%s.png;hb=HEAD\" width=\"32px\" height=\"32px\" alt=\"-\"/>\n", category, icon_name[j]);

#define ICON_48		printf ("\t\t\t<img src=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/48x48/%s/%s.png;hb=HEAD\" width=\"48px\" height=\"48px\" alt=\"-\"/>\n", category, icon_name[j]);

#define ICON_SVG	printf ("\t\t\t<a href=\"http://git.fedorahosted.org/git/?p=echo-icon-theme;a=blob_plain;f=base/scalable/%s/%s.svg;hb=HEAD\">%s</a>", category, icon_name[j], icon_name[j]);

int process_table (char *input, char *category)
{
//	printf ("%s\n\n", input);

	FILE *fi;
	int i, j;
	char icon_name [COLS][256];
	int aux;
	
	fi = fopen (input, "r");
	if (!fi) 
	{
		fprintf(stderr, "Unable to open input file: %s.\n", input);
		return -1;
	}

	i = 0;

	printf ("<table style=\"border:  none 0;width: 100%; text-align: center;\">\n");	

	do 
	{
		if (i == COLS)
		{
			printf ("\t<tr>\n");
			i = 0;
			for (j = 0; j < COLS; j++)
			{
				printf ("\t\t<td>\n");
				
				ICON_16					
				ICON_22					
				ICON_32					
				ICON_48					
				
				printf ("\t\t</td>\n");
			}
			printf ("\t</tr>\n");

			printf ("\t<tr>\n");
			for (j = 0; j < COLS; j++)
			{
				printf ("\t\t<td>\n");
				
				ICON_SVG				
			
				printf ("\t\t</td>\n");
			}
			printf ("\t</tr>\n");
			printf ("\t<tr style=\"height: 2em;\"></tr>\n\n");
		}
//		aux = fgetc (fi);
//		printf ("%d", aux);
		fscanf (fi, "%s", icon_name[i]);
		aux = fgetc (fi);
//		printf ("%s\n", icon_name);
		i++;
		
	} while (!(aux == -1));

	i--;
	printf ("\t<tr>\n");
	for (j = 0; j < i; j++)
	{
		printf ("\t\t<td>\n");

		ICON_16					
		ICON_22					
		ICON_32					
		ICON_48					
	
		printf ("\t\t</td>\n");
	}
	printf ("\t</tr>\n");

	printf ("\t<tr>\n");
	for (j = 0; j < i; j++)
	{
		printf ("\t\t<td>\n");
		
		ICON_SVG				
	
		printf ("\t\t</td>\n");
	}
	printf ("\t</tr>\n");
	printf ("\t<tr style=\"height: 2em;\"></tr>\n\n");


	printf ("</table>\n");
	fclose (fi);

	return 0;
}

int main(int argc, char *argv[])
{
	char *input;
	char *category;
	if (argc < 3)
	{
		fprintf(stderr, "Missing argument!\nUsage: generate-status-table <input-file> <category>\n");
		return (1);
	}
	input = argv[1];
	category = argv[2];
	int i = process_table (input,category);

	return i;
}
